import { Document, Schema, model } from 'mongoose';

export interface ModerationInterface extends Document {
  username: string,
  userId: string,
  logId: string,
  moderatorId: string,
  reason: string,
  /**
   * @field 0 - Create
   * @field 1 - Warn
   * @field 2 - Lock
   * @field 3 - Unlock
   * @field 4 - Delete
   */
  type: 0 | 1 | 2 | 3 | 4
  date: Date,
  expiration: {
    date: Date,
    processed: boolean
  }
}

const Moderation = new Schema<ModerationInterface>({
  username: String,
  userId: String,
  logId: String,
  moderatorId: String,
  reason: String,
  type: Number,
  date: Date,
  expiration: {
    date: Date,
    processed: Boolean,
  },
});

export default model<ModerationInterface>('Moderation', Moderation);
